[<prev] [next>] [<thread-prev] [thread-next>] [day] [month] [year] [list]
Message-Id: <1395352845-7435-1-git-send-email-holler@ahsoftware.de>
Date: Thu, 20 Mar 2014 23:00:45 +0100
From: Alexander Holler <holler@...oftware.de>
To: linux-kernel@...r.kernel.org
Cc: Andrew Morton <akpm@...ux-foundation.org>,
Alexander Holler <holler@...oftware.de>
Subject: [PATCH v2] initramfs: print error and shell out for unsupported content
The initramfs generation is broken for file and directory names which contain
colons or spaces. Print an error and don't try to continue.
Tests:
cd linux
make defconfig
echo 'CONFIG_BLK_DEV_INITRD=y' >> .config
echo 'CONFIG_INITRAMFS_ROOT_UID=0' >>.config
echo 'CONFIG_INITRAMFS_ROOT_GID=0' >>.config
echo 'CONFIG_INITRAMFS_COMPRESSION_NONE=y' >>.config
echo 'CONFIG_INITRAMFS_SOURCE="/tmp/bugroot"' >>.config
Problem with colons:
mkdir -p /tmp/bugroot/a:b
make -j4 bzImage # no error
make bzImage # try again, oops
Problem with spaces:
mkdir -p /tmp/bugroot/a\ b
make -j4 bzImage # no error
zcat usr/initramfs_data.cpio.gz | cpio --extract --list # oops, no content
Signed-off-by: Alexander Holler <holler@...oftware.de>
---
Silly and trivial changes in v2: Fixed a typo and added 'colons and spaces'
scripts/gen_initramfs_list.sh | 12 ++++++++++++
1 file changed, 12 insertions(+)
diff --git a/scripts/gen_initramfs_list.sh b/scripts/gen_initramfs_list.sh
index 17fa901..8f4c145 100644
--- a/scripts/gen_initramfs_list.sh
+++ b/scripts/gen_initramfs_list.sh
@@ -171,6 +171,18 @@ dir_filelist() {
${dep_list}header "$1"
srcdir=$(echo "$1" | sed -e 's://*:/:g')
+
+ # Files and directories with spaces and colons are unsupported.
+ local unsupported=$(find "${srcdir}" -regex '.*\(:\| \).*')
+ if [ ! -z "${unsupported}" ]; then
+ printf "ERROR: Unable to handle files/directories with " >&2
+ printf "unsupported characters (spaces and colons).\n" >&2
+ printf "Please use other ways to generate a cpio-archive. " >&2
+ printf "Unsupported files and directories are:\n" >&2
+ printf "$unsupported\n" >&2
+ exit 1
+ fi
+
dirlist=$(find "${srcdir}" -printf "%p %m %U %G\n")
# If $dirlist is only one line, then the directory is empty
--
1.8.3.1
--
To unsubscribe from this list: send the line "unsubscribe linux-kernel" in
the body of a message to majordomo@...r.kernel.org
More majordomo info at http://vger.kernel.org/majordomo-info.html
Please read the FAQ at http://www.tux.org/lkml/
Powered by blists - more mailing lists